#include <avr/io.h>

.extern Elmcie
.extern Elm_high

/* 
   Interrupt routine for timer1.
   Just increases Elmcie_Count to achieve higher
   resolution, 16 from the timer and 16 from the
   variable, giving a 32 bits value.
*/
.global TIMER1_OVF_vect
TIMER1_OVF_vect:
	push r24
	in   r24, _SFR_IO_ADDR(SREG)
	push r24
	push r25

	lds  r24, Elmcie+2
	lds  r25, Elmcie+3
	adiw r24, 1
	sts  Elmcie+2, r24
	sts  Elmcie+3, r25

	pop  r25
	pop  r24
	out  _SFR_IO_ADDR(SREG), r24
	pop  r24
	reti


/*
   Interrupt routine for the analog comparator used in Elm
*/
.global ANALOG_COMP_vect
ANALOG_COMP_vect:
	push r24
	in   r24, _SFR_IO_ADDR(SREG)
	push r24
	push r25

	; If DDRD4 = 1, threshold is low, else is high
	sbis _SFR_IO_ADDR(DDRD), 4
	rjmp High_tresh
	cbi  _SFR_IO_ADDR(DDRD), 4
	lds  r24, TCNT1L
	lds  r25, TCNT1H
	sts  Elm_high, r24
	sts  Elm_high+1, r25
	lds  r24, Elmcie+2
	lds  r25, Elmcie+3
	sts  Elm_high+2, r24
	sts  Elm_high+3, r25
	in	 r24, _SFR_IO_ADDR(ACSR)
	ori  r24, _BV(ACI)
	out  _SFR_IO_ADDR(ACSR), r24
	rjmp Treshold_passed_exit

High_tresh:
	lds  r24, TCCR1B
	andi r24, 0xFF - _BV(CS10)
	sts  TCCR1B, r24

	lds  r24, TCNT1L
	lds  r25, TCNT1H
	sts  Elmcie, r24
	sts  Elmcie+1, r25
	sbi  _SFR_IO_ADDR(DDRD), 4
	in   r24, _SFR_IO_ADDR(ACSR)
	andi r24, 0xFF - _BV(ACIE)
	ori  r24, _BV(ACI)
	out  _SFR_IO_ADDR(ACSR), r24
	sbi  _SFR_IO_ADDR(GPIOR0), 0
	
Treshold_passed_exit:
	pop  r25
	pop  r24
	out  _SFR_IO_ADDR(SREG), r24
	pop  r24
	reti
