#ifndef GLOBAL_H
#define GLOBAL_H

typedef struct {
  unsigned char bit0:1;
  unsigned char bit1:1;
  unsigned char bit2:1;
  unsigned char bit3:1;
  unsigned char bit4:1;
  unsigned char bit5:1;
  unsigned char bit6:1;
  unsigned char bit7:1;
} io_reg;

#define Elm_disch			( (volatile io_reg*)(&DDRD) )->bit6
#define Elm_low_threshold	( (volatile io_reg*)(&DDRD) )->bit4
#define N_elm3k3_lm311on	( (volatile io_reg*)(&PORTD) )->bit3
#define Do_l				( (volatile io_reg*)(&PORTB) )->bit0
#define Backlight_hi		( (volatile io_reg*)(&PORTB) )->bit1
#define SW1_n				( (volatile io_reg*)(&PINC) )->bit3
#define SW2_n				( (volatile io_reg*)(&PINC) )->bit2

#define Status	GPIOR0

#define Elm_selected	( (volatile io_reg*)(&Status) )->bit7
#define Elm_large_caps	( (volatile io_reg*)(&Status) )->bit6
#define Do_nulling		( (volatile io_reg*)(&Status) )->bit5
#define Do_calibration	( (volatile io_reg*)(&Status) )->bit4
#define Elcie_cap		( (volatile io_reg*)(&Status) )->bit3
#define Elm_missed_it	( (volatile io_reg*)(&Status) )->bit2
#define Elm_timeout		( (volatile io_reg*)(&Status) )->bit1
#define Elm_ready		( (volatile io_reg*)(&Status) )->bit0


// Hold_time is the time (in ms) that identifies a key hold
#define Hold_time	500

// Key_hold is the number of ticks from the timer needed
// 			to reach Hold_time
// 	Equals Hold_time/(OCR*Prescaler/(F_CPU/1000))
#define Key_Hold 	Hold_time/(256*1024/(F_CPU/1000))

// SWn_press is set if it was only a key press (t < 500 ms)
//
// SWn_hold is set if the key was hold after a while (t < 500 ms)
//
// SWn_cur_value is the current value being read while the key
//				 is being pressed.
//
// SWn_last_value is the value of the last key press.
//				  It is updated after the key is released.

typedef struct {
	unsigned char SW1_press:1;
	unsigned char SW1_hold:1;
	unsigned char SW2_press:1;
	unsigned char SW2_hold:1;
	unsigned char SW1_last_value;
	unsigned char SW1_cur_value;
	unsigned char SW2_last_value;
	unsigned char SW2_cur_value;
} SW_status;

// Variable definitions
volatile uint8_t Cnt_10ms;
volatile uint16_t Elmcie_Count;
volatile uint32_t Total_Counts;
volatile uint32_t Elm_high;
volatile SW_status Switches;

//uint8_t Status	// defined above to use GPIO
uint8_t Status_copy;

#endif
